<template>
	<div>
		<NavbarTop></NavbarTop>
		<h2>GPS Map</h2>
		<div id="mapContainer">
			<!-- https://developer.here.com/develop/javascript-api -->
		</div>
	</div>
</template>

<script>
	import NavbarTop from '@/components/NavbarTop'
	import Vue2Leaflet from '@/components/leaflet'
	export default {
		components: {
			NavbarTop, Vue2Leaflet
		},
		data() {
			return {
				LMap: '',
				zoom: 13,
				center: L.latLng(0, 0),
				url: 'http://{s}.tile.osm.org/{z}/{x}/{y}.png',
				attribution: '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors',
				marker: L.latLng(0, 0),
			}
		},
		methods: {
			initMap () {
				var vm = this
				if (navigator.geolocation) {
					navigator.geolocation.getCurrentPosition(vm.initPosition);
				} else {
					alert("Geolocation is not supported by this browser, sorry :(");
				}
				vm.LMap = L.map('mapContainer', {
					center: vm.center,
					zoom: 13
				});
				L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
					attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
				}).addTo(vm.LMap);

				L.marker(vm.center).addTo(vm.LMap)
				.bindPopup('You are here!')
				.openPopup();

				// vm.swapMarker()
			},
			initPosition (position) {
				this.center = L.latLng(position.coords.latitude, position.coords.longitude)
				this.marker = L.latLng(position.coords.latitude, position.coords.longitude)
			},
			swapMarker () {
				var markerPanel = document.querySelector('.leaflet-marker-pane')
				if (markerPanel)
					markerPanel.childNodes[0].src = "https://image.flaticon.com/icons/svg/33/33622.svg"
			},
			addMarker () {
				L.marker(this.center).addTo(this.LMap)
				.bindPopup('You are here!')
				.openPopup();
			}
		},
		mounted() {
			this.initMap()
		},
		watch: {
			center: function(val) {
			},
			marker: function(val) {
				if (val) {
					var marker = document.querySelector('.leaflet-marker-icon')
					var markerPanel = document.querySelector('.leaflet-marker-pane').removeChild(marker)
					this.addMarker();
					this.swapMarker();
				}
			}
		}
	}
</script>

<style scoped>
#mapContainer {
	width: 60%;
	height: 500px;
	margin: auto;
	overflow: hidden;
}
</style>
